package de.netxp.smscreator.helper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Calendar;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.ErrorListener;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.xmlbeans.SchemaType;
import org.apache.xmlbeans.impl.tool.SchemaCompiler;
import org.w3c.dom.DOMError;
import org.w3c.dom.DOMErrorHandler;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.sun.corba.se.impl.orbutil.ObjectUtility;

import de.smscreator.gateway.ArrayOfString;
import de.smscreator.gateway.SendSMSDocument.SendSMS;
import de.smscreator.gateway.impl.ArrayOfStringImpl;
import de.smscreator.gateway.impl.SendSMSDocumentImpl;
import de.smscreator.gateway.impl.SmsTextTypImpl;
import de.smscreator.gateway.impl.SendSMSDocumentImpl.SendSMSImpl;

public class Soap2JavaHelper {

	public Soap2JavaHelper() {
	}
	
	public void soap2Java() throws Exception {
	  //String urlSend = "http://www.smscreator.de/gateway/Send.asmx?WSDL";
	  
    String fileSend = "send.wsdl";
    //String fileSendPatched = "sendpatched.wsdl";
	  
	  //this.downloadFile(urlSend, fileSend);

	  //this.patchArray(fileSend, fileSendPatched);
	  
    this.generateJava(fileSend);
    //this.generateJava(fileSendPatched);
	}
	
  /**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Soap2JavaHelper helper = new Soap2JavaHelper();
		helper.soap2Java();
	}
	
	public void SendSMS()
	{
	  SchemaType sType = null;
	  SendSMSImpl impl = new SendSMSImpl(sType);
    
    ArrayOfString aos = new ArrayOfStringImpl(sType);
    
    impl.setUser("");
    impl.setPassword("");

    impl.setRecipient(aos);
    impl.setSender("");

    impl.setSendDate(Calendar.getInstance());
    impl.setSmsTyp(SmsTextTypImpl.STANDARD);

    impl.setCaption("test");
    impl.setSMSText("");
    
    
	}
	

	private void downloadFile(String target, String file) throws IOException {
	  URL url = new URL(target);
	  BufferedReader br = new BufferedReader(new InputStreamReader(url.openStream()));
	  FileWriter fw = new FileWriter(file);;

	  String line = null;
	  while ((line= br.readLine()) != null) {
	    fw.write(line);
	    fw.write("\r\n");
	  }
	  
    fw.close();
	}
	
	private void generateJava(String file) {
    ArrayList<String> args = new ArrayList<String>();
    args.add("-src");
    args.add("src");
    args.add("-srconly");
    args.add(file);
    
    SchemaCompiler.main(args.toArray(new String[args.size()]));
	}

  private void patchArray(String file, String newFile) throws ParserConfigurationException, SAXException, IOException, TransformerException {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    dbf.setNamespaceAware(true);
    dbf.setXIncludeAware(false);
    dbf.setExpandEntityReferences(false);
    
    ErrorHandler eh = new ErrorHandler() {
      
      @Override
      public void warning(SAXParseException arg0) throws SAXException {
        System.out.println("Warning " + arg0.toString());
      }
      
      @Override
      public void fatalError(SAXParseException arg0) throws SAXException {
        System.out.println("fatal " + arg0.toString());
      }
      
      @Override
      public void error(SAXParseException arg0) throws SAXException {
        System.out.println("error " + arg0.toString());
      }
    }; 
    
    DocumentBuilder db = dbf.newDocumentBuilder();
    
    db.setErrorHandler(eh);
    
    Document d = db.parse(new File(file));
    
    NodeList nl = d.getElementsByTagName("s:restriction");
    for (int idx=0; idx< nl.getLength(); idx++)
    {
      Node n = nl.item(idx); 
      
      if ("soapenc:Array".equals(n.getAttributes().getNamedItem("base").getTextContent()))
      {
        Node parent = n.getParentNode().getParentNode(); 
        for (int idxnodes = 0; idxnodes < n.getChildNodes().getLength(); idxnodes++)
        {
          parent.appendChild(n.getChildNodes().item(idxnodes).cloneNode(true));
        }
        parent.removeChild(n.getParentNode());
      }
    }
    
    FileWriter fw = new FileWriter(newFile);

    TransformerFactory tf = TransformerFactory.newInstance();
    tf.setErrorListener(new ErrorListener() {
      
      @Override
      public void warning(TransformerException arg0) throws TransformerException {
        System.out.println("Warning " + arg0.toString());
      }
      
      @Override
      public void fatalError(TransformerException arg0) throws TransformerException {
        System.out.println("Warning " + arg0.toString());
      }
      
      @Override
      public void error(TransformerException arg0) throws TransformerException {
        System.out.println("Warning " + arg0.toString());
      }
    });
    
    Transformer t = tf.newTransformer();
    t.setOutputProperty(OutputKeys.ENCODING, "UTF8");
    t.setOutputProperty(OutputKeys.METHOD, "xml");
    t.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "no");
    t.setOutputProperty(OutputKeys.STANDALONE, "yes");
    //t.setOutputProperty(OutputKeys., value)
    DOMSource s = new DOMSource(d);
    
    StreamResult sr = new StreamResult(fw);
    t.transform(s, sr);
    
    
    fw.close();
    
  }

  private void patchArrayNew(String file, String newFile) throws IOException {
    BufferedReader in = new BufferedReader(new FileReader(file));
    BufferedWriter out = new BufferedWriter(new FileWriter(newFile));
    
    StringBuilder sb = new StringBuilder();
    String line = null;
    while ((line = in.readLine()) != null)
    {
      sb.append(line);
      sb.append("\r\n");
    }
    
    //int start = sb.indexOf("")
    
    in.close();
    out.close();
  }
}
